% !TeX spellcheck = en_US
% !TEX encoding = UTF-8 Unicode
\documentclass[a4paper, 12pt]{article}
\PassOptionsToPackage{dvipsnames}{xcolor}\usepackage{listings} 
\usepackage{amsmath}
\usepackage{amsthm}
\usepackage{amsbsy}
\usepackage{trfsigns}
\usepackage{wasysym}
\usepackage{amssymb}
\usepackage{bm} %fatmath
\usepackage[utf8]{inputenc} % this is needed for umlauts
\usepackage[english]{babel} % this is needed for umlauts
\usepackage[T1]{fontenc}    % this is needed for correct output of umlauts in pdf
\usepackage{fontspec}
\usepackage[top=1.5cm,bottom=3cm,left=3cm,right=1.5cm]{geometry}
\usepackage{fancyhdr}  % needed for the footer
\usepackage{lastpage}  % needed for the footer
\usepackage{subfig}
\usepackage{tabularx}
\usepackage{graphicx}
\usepackage[font={small},labelfont=bf]{caption}
\usepackage[separate-uncertainty=true,output-decimal-marker={,} ]{siunitx}
\DeclareSIUnit\permille{\text{\textperthousand}}
\usepackage{blindtext}
\usepackage{chemformula}
\usepackage{bm}
\usepackage[style=chem-angew,biblabel=brackets, backend=biber]{biblatex}
\usepackage{booktabs}

\usepackage{lmodern}
\usepackage{verbatim}
\PassOptionsToPackage{hyphens}{url}\usepackage{hyperref} %add [pdfpagelayout=TwoPageRight] for twopaged Layout


\usepackage{pdfpages}
\lstset{language=C++,
	belowskip=-\baselineskip,
	keywordstyle=\color{blue},
	stringstyle=\color{red},
	commentstyle=\color{Green},
	morecomment=[l][\color{magenta}]{\#},
	basicstyle=\scriptsize,
	numbers=left,
	frame=single,
	breaklines=true,
	captionpos=b,
	numberstyle=\scriptsize\textcolor{gray},
	showstringspaces=false
	￼       %identifierstyle=,
	%stringstyle=\ttfamily
}
\renewcommand{\lstlistingname}{Quelltext}
\newcommand{\lstcpp}[1]{
	\lstinputlisting[
	caption=#1.cpp,
	label=lst:#1cpp
	]{LocalSpinMultiplicity/src/#1.cpp}
}
\newcommand{\lsth}[1]{
	\lstinputlisting[
	caption=#1.h,
	label=lst:#1h
	]{LocalSpinMultiplicity/include/#1.h}
}
\newcommand{\lsttest}[1]{
	\lstinputlisting[
	caption=#1.cpp,
	label=lst:#1cpp
	]{LocalSpinMultiplicity/src/tests/#1.cpp}
}
\newcommand{\lstclass}[1]{
	\lsth{#1}
	\lstcpp{#1}
}

\renewcommand{\thesection}{\arabic{section}}
\renewcommand{\thesubsection}{\thesection.\arabic{subsection}}
\renewcommand{\thefigure}{\thesection.\arabic{figure}}
\renewcommand{\theequation}{\thesection.\arabic{equation}}
\renewcommand{\thetable}{\thesection.\arabic{table}}
\numberwithin{equation}{section}
\numberwithin{figure}{section}
\numberwithin{table}{section}

\lstdefinelanguage{mybash}
{
	language=bash,
	basicstyle=\ttfamily
}

\lstdefinelanguage{mypython}
{
	language=python,
	basicstyle=\ttfamily
}


\makeatletter
\newcommand{\rightorleftmark}{%
	\begingroup\protected@edef\x{\rightmark}%
	\ifx\x\@empty
	\endgroup\leftmark
	\else
	\endgroup\rightmark
	\fi}
\makeatother


\bibliography{literature}
\bibliography{database}
\clubpenalty  = 10000 % Schusterjungen verhindern
\widowpenalty = 10000 % Hurenkinder verhindern
\setlength{\parskip}{0.8cm plus0.2cm minus0.2cm}
\setlength{\parindent}{0pt}
\newcolumntype{C}{>{\centering\arraybackslash}X}
\newcolumntype{L}[1]{>{\raggedright\arraybackslash}p{#1}} % linksbündig mit Breitenangabe


\newcommand{\ii}{\mathrm{i}}
\newcommand{\WFrRt}{\Phi}
\newcommand{\WFrR}{\Phi}
\newcommand{\WFt}{\varphi}
\newcommand{\WFR}{\chi}
\newcommand{\WFr}{\Psi}
\newcommand{\WFMO}{\phi}
\newcommand{\WFAO}{\chi}
\newcommand{\WFPMO}{\psi}
\newcommand{\WFSD}{\psi}

\newcommand{\Hop}{\bm{\hat{H}}}
\newcommand{\Hope}{\bm{\hat{H}}_\text{e}}
\newcommand{\Top}{\bm{\hat{T}}}
\newcommand{\Tope}{\bm{\hat{T}}_\text{e}}
\newcommand{\TopK}{\bm{\hat{T}}_\text{K}}
\newcommand{\Vop}{\bm{\hat{V}}}
\newcommand{\Vopee}{\bm{\hat{V}}_\text{ee}}
\newcommand{\VopKK}{\bm{\hat{V}}_\text{KK}}
\newcommand{\VopKe}{\bm{\hat{V}}_\text{Ke}}

\newcommand{\mycite}[1]{\textsuperscript{\cite{#1}}}

\setlength\extrarowheight{2pt}
\newcommand\titleGER{Kontrollierte Kupferoxidation zur Verbesserung des Trockentransfers von CVD-Graphen}
\newcommand\titleENG{Controlled Copper Oxidation for improved Dry-Transfer of CVD-grown Graphene}
\newcommand{\presentingDate}{16.07.2018}
\author{Morian Sonnet}
\date{\presentingDate}

\fancypagestyle{frontmatter}{
	\fancyhead{}
	\renewcommand{\headrulewidth}{0pt}
	\renewcommand{\footrulewidth}{1.5pt}
	\fancyfoot{}
	\fancyfoot[R]{\thepage}
	\fancyfoot[C]{Morian Sonnet}
}

\fancypagestyle{mainmatter}{
\renewcommand{\headrulewidth}{1.5pt}
\renewcommand{\footrulewidth}{1.5pt}
	\fancyhead[R]{\rightorleftmark}
	\fancyfoot[C]{Morian Sonnet}
	\fancyfoot[R]{Seite \thepage{} von \pageref{lastpage}}
}

\fancypagestyle{backmatter}{
\renewcommand{\headrulewidth}{1.5pt}
\renewcommand{\footrulewidth}{1.5pt}
	\fancyhead[R]{\leftmark}
	\fancyfoot[R]{Seite A-\thepage{} von A-\pageref{Anhanglastpage}}
	\fancyfoot[C]{Morian Sonnet}
}

\fancypagestyle{newchapterMAIN}{
\renewcommand{\headrulewidth}{0pt}
\renewcommand{\footrulewidth}{1.5pt}
	\fancyhead{}
	\fancyfoot[R]{Seite \thepage{} von \pageref{lastpage}}
	\fancyfoot[C]{Morian Sonnet}
}
\fancypagestyle{newchapterBACK}{
\renewcommand{\headrulewidth}{0pt}
\renewcommand{\footrulewidth}{1.5pt}
	\fancyhead{}
	\fancyfoot[R]{Seite A-\thepage{} von A-\pageref{Anhanglastpage}}
	\fancyfoot[C]{Morian Sonnet}
}

\newenvironment{tightcenter}{
	\setlength\topsep{0pt}
	\setlength\parskip{0pt}
	\begin{center}
	}{
	\end{center}
}

\pagestyle{fancy}
\renewcommand\sectionmark[1]{\markboth{\thesection{} #1}{\thesection{} #1}}
%\pagestyle{fancy}
%\renewcommand\sectionmark[1]{bla}
%\renewcommand\chaptermark[1]{blub}

\begin{document}
	\pagestyle{plain}
\begin{center} \Huge Documentation\\
	\huge \textit{Logging Unit for Humidifier}\\[0.2cm]
	\normalsize Morian Sonnet, \today\\
	\small MorianSonnet@googlemail.com
\end{center} \vspace{1cm}
\tableofcontents\clearpage
\section{Setting up new Unit}
\subsection{Used hardware}
\begin{itemize}
	\item Raspberry Pi with
	\subitem Power Adapter
	\subitem MicroSD-Card (8 GB, Class 4 is recommended)
	\item SHT31-D humidity and temperature sensor
	\item USB Stick (to log onto)
\end{itemize}
\subsection{Create Raspbian SD-Card}
This part is assuming you have access to a Linux Computer's command line interface. Not installed software, e.g. \texttt{wget} should be installed when necessary.\\[0.5cm]
First, create a new folder and start the Raspbian download.
\begin{lstlisting}[language={mybash}]
cd ~
mkdir raspbian_download -p
cd raspbian_download
wget https://downloads.raspberrypi.org/raspbian_latest -O raspbian.zip
\end{lstlisting}
The last command will download the newest version of Raspbian. This can lead to problems, due to incompatibilities with used external software. If you notice these, you should use the following instead.
\begin{lstlisting}[language={mybash}]
wget http://downloads.raspberrypi.org/raspbian/images/raspbian-2018-04-19/2018-04-18-raspbian-stretch.zip -O raspbian.zip
\end{lstlisting}
The downloaded file is then unzipped:
\begin{lstlisting}[language={mybash}]
unzip raspbian.zip
\end{lstlisting}
Now the Raspbian image need to be transferred onto the MicroSD-Card. The device name of the Card is recognized by running
\begin{lstlisting}[language={mybash}]
lsblk
\end{lstlisting}
before and after plugging in the Card.\\
A standard output of this command is
\begin{lstlisting}[language={mybash}]
NAME            MAJ:MIN RM   SIZE RO TYPE MOUNTPOINT
sda               8:0    0 931.5G  0 disk 
├─sda1            8:1    0   585G  0 part 
├─sda2            8:2    0   200M  0 part /boot/efi
├─sda3            8:3    0     1G  0 part /boot
├─sda4            8:4    0 198.8G  0 part 
│ ├─fedora-root 253:0    0 162.5G  0 lvm  /
│ ├─fedora-swap 253:1    0   7.8G  0 lvm  [SWAP]
│ └─fedora-home 253:2    0   175G  0 lvm  /home
└─sda5            8:5    0 146.5G  0 part 
├─fedora-root 253:0    0 162.5G  0 lvm  /
└─fedora-home 253:2    0   175G  0 lvm  /home
mmcblk0         179:0    0   3.7G  0 disk 
└─mmcblk0p1     179:1    0   3.7G  0 part /run/media/2289
\end{lstlisting}
wherein the bottom two lines only appear after plugging in the SD-Card. To transfer the image successfully, the corresponding device should not be mounted. The mount status of the device can be recognized by checking the entry of the \texttt{MOUNTPOINT} column. To unmount type
\begin{lstlisting}[language={mybash}]
sudo umount /dev/mmcblk0p1
\end{lstlisting}
Thereby replace \texttt{mmcblk0p1} by the corresponding name stated in the \texttt{NAME} column.\\
To transfer the image, type
\begin{lstlisting}[language={mybash}]
sudo dd of=/dev/mmcblk0 if=2018-04-18-raspbian-stretch.img bs=4M status=progress
\end{lstlisting}
Again, replace the name of the image and device by the corresponding values for your system. If \texttt{dd} has a problem with the \texttt{status} option you can remove it.
\subsection{Raspberry Pi Basic Setup}
For this part the Raspberry Pi should be connected by a keyboard and a screen.\\[0.5cm]
Start by plugging the just created SD-Card into the Raspberry Pi and starting it by connecting the power adapter.\\
After successful startup, desktop should be visible. To switch into command line, press \texttt{Ctrl+Alt+F3}. You are asked then to log in. The login data is \texttt{pi} (username) and \texttt{raspberry} (password, watch out for QWERTY keyboard layout). By typing
\begin{lstlisting}[language={mybash}]
sudo raspi-config
\end{lstlisting}
the interactive Configuration of the Raspberry becomes visible. The following changes are necessary or useful. Since the interactive Configuration is quite intuitive, no further explanation is given. The enumeration number equals the number of the Configuration tool.
\begin{enumerate}
	\item Change the password of user \texttt{pi} (useful)
	\item Connect to WIFI (necessary)
	\item Activate command line on bootup (B1, useful) and disable splash screen (B3, useful)
	\item Set appropriate timezone (necessary) and change keyboard layout (useful)
	\item Activate SSH (useful) and I2C (necessary)
\end{enumerate}
After WiFi connection is established, the Raspberry can be updated by
\begin{lstlisting}[language={mybash}]
sudo apt-get update
sudo apt-get upgrade -y
\end{lstlisting}
However note, that updating the software can break the intended purpose, due to incompatibilities with newer software.
\subsection{Setup of the logging software}
First of all, the code for the logging unit needs to be downloaded.
\begin{lstlisting}[language={mybash}]
git clone https://git.rwth-aachen.de/morian.sonnet/RPI_WEB.git
cd RPI_WEB
chmod +x setup*.sh
\end{lstlisting}
Connect the sensor to the Raspberry Pi (refer to section \ref{sensor_connect}) and type
\begin{lstlisting}{language={mybash}}
i2cdetect -y 1
\end{lstlisting}
If properly installed, the output should look like 
\begin{lstlisting}{language={mybash}}
     0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
00:          -- -- -- -- -- -- -- -- -- -- -- -- -- 
10: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
20: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
30: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
40: -- -- -- -- 44 -- -- -- -- -- -- -- -- -- -- -- 
50: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
60: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
70: -- -- -- -- -- -- -- --                         
\end{lstlisting}
showing that the sensor with address \texttt{0x44} is ready for communication.\\[0.5cm]
Next step is configuring the automatic mounting of an USB stick. To do so run
\begin{lstlisting}[language={mybash}]
sudo ./setup1.sh
\end{lstlisting}
This will install the \texttt{usbmount} package and do a few configurations. It will finally reboot the Raspberry. If the script crashes, due to networking errors, just restart it.\\
\begin{comment}
Install the \texttt{usbmount}-package by
\begin{lstlisting}[language={mybash}]
sudo apt-get install usbmount -y
\end{lstlisting}
This package unfortunately does not work out of the box anymore. To make it work, type
\begin{lstlisting}[language={mybash}]
sudo systemctl edit systemd-udevd
\end{lstlisting}
Now, add 
\begin{lstlisting}[language={mybash}]
[Service]
MountFlags=shared
\end{lstlisting}
to the bottom of the file and press \texttt{Ctrl+O}, \texttt{Enter} and finally \texttt{Ctrl+X} to leave the editor.\\[0.5cm]
Further, type 
\begin{lstlisting}[language={mybash}]
sudo nano /etc/usbmount/usbmount.conf
\end{lstlisting}
and change the line 
\begin{lstlisting}[language={mybash}]
FS_MOUNTOPTIONS=""
\end{lstlisting}
into 
\begin{lstlisting}[language={mybash}]
FS_MOUNTOPTIONS="-fstype=vfat,gid=users,dmask=0007,fmask=0117"
\end{lstlisting}
Again, save and exit with \texttt{Ctrl+O}, \texttt{Enter} and finally \texttt{Ctrl+X}.\\
\end{comment}
After the Raspberry Pi is boot up again a freshly plugged in USB stick should be mounted at \texttt{/media/usb0}. Verify this by plugging in a USB stick and typing
\begin{lstlisting}[language={mybash}]
lsblk | grep "usb0" -B 1
\end{lstlisting}
which should give something similar to 
\begin{lstlisting}[language={mybash}]
sda           8:0    1  7.5G  0 disk 
└─sda1        8:1    1  7.5G  0 part /media/usb0
\end{lstlisting}
To finally run the logging software, further packages are needed.
Type 
\begin{lstlisting}[language={mybash}]
cd RPI_WEB
sudo ./setup2.sh
\end{lstlisting}
Again, if networking errors occur, restart the script. After successfully running the script, the application should run.\\
During execution of the application itself, no errors should appear. Try plugging in a USB stick and removing it. The application should emit some messages about the USB stick. Exit by pressing \texttt{Ctrl+C} twice.\\[0.5cm]
The last step is generating a WiFi Adhoc Network, to easily access the Data.
The default SSID (name) of the network is \texttt{RPI} with password \texttt{AardvarkBadgerHedghehog}. If you want to change these type
\begin{lstlisting}[language={mybash}]
nano setup_files/hostapd
\end{lstlisting}
and change the lines
\begin{lstlisting}[language={mybash}]
ssid=RPI
...
wpa_passphrase=AardvarkBadgerHedgehog
\end{lstlisting}
according your wishes. Save and close the file by pressing \texttt{Ctrl+O}, \texttt{Enter} and \texttt{Ctrl+X}.\\
To continue installing the necessary software type
\begin{lstlisting}[language={mybash}]
sudo ./setup3.sh
\end{lstlisting}
Restart this script, if networking errors corrupt downloading the packages. Finally, after successfully running the script, press \texttt{Enter}. The Raspberry Pi is again rebooted.\\[0.5cm]
Above script also configures automatic start of the logging application at boot up. Connect with another device to the WiFi network of the Raspberry Pi and head to (in the browser)
\begin{comment}
\begin{lstlisting}[language={mybash}]
sudo apt-get install dnsmasq hostapd -y
sudo systemctl stop dnsmasq
sudo systemctl stop hostapd
sudo echo -e "interface wlan0\n   static ip_address=192.168.4.1/24" >> /etc/dhcpcd.conf
sudo mv /etc/dnsmasq.conf /etc/dnsmasq.conf.orig
sudo nano /etc/dnsmasq.conf
\end{lstlisting}
Now add 
\begin{lstlisting}[language={mybash}]
interface=wlan0      
    dhcp-range=192.168.4.2,192.168.4.20,255.255.255.0,24h
\end{lstlisting}
and save and exit the usual way. Further, type
\begin{lstlisting}[language={mybash}]
sudo nano /etc/hostapd/hostapd.conf
\end{lstlisting}
and add 
\begin{lstlisting}[language={mybash}]
interface=wlan0
driver=nl80211
ssid=NameOfNetwork
hw_mode=g
channel=6
wmm_enabled=0
macaddr_acl=0
auth_algs=1
ignore_broadcast_ssid=0
wpa=2
wpa_passphrase=AardvarkBadgerHedgehog
wpa_key_mgmt=WPA-PSK
wpa_pairwise=TKIP
rsn_pairwise=CCMP
\end{lstlisting}
to the file. Thereby you should exchange the \texttt{ssid} and \texttt{wpa\_passphrase} by appropriate values. After that,
\begin{lstlisting}[language={mybash}]
sudo nano /etc/default/hostapd
\end{lstlisting}
and replace 
\begin{lstlisting}[language={mybash}]
#DAEMON_CONF
\end{lstlisting} by 
\begin{lstlisting}[language={mybash}]
DAEMON_CONF="/etc/hostapd/hostapd.conf"
\end{lstlisting}
Close and save the file. Type now
\begin{lstlisting}[language={mybash}]
sudo nano /etc/hosts
\end{lstlisting}
and add the line
\begin{lstlisting}[language={mybash}]
192.168.4.1      raspi
\end{lstlisting}
Close and save the file. Last but not least, the automatic connection to the prexisting network should be removed.
For this
\begin{lstlisting}[language={mybash}]
sudo nano /etc/wpa_supplicant/wpa_supplicant.conf
\end{lstlisting}
and remove the section starting with 
\begin{lstlisting}[language={mybash}]
network={
\end{lstlisting}
Close and save the file. Type
\begin{lstlisting}[language={mybash}]
sudo nano /etc/sysctl.conf
\end{lstlisting}
and uncomment the line 
\begin{lstlisting}[language={mybash}]
net.ipv4.ip_forward=1
\end{lstlisting}
by removing the \texttt{\#} in front of the line. Close and save the file. Then type
\begin{lstlisting}[language={mybash}]
sudo iptables -t nat -A POSTROUTING -o eth0 -j MASQUERADE
sudo sh -c "iptables-save > /etc/iptables.ipv4.nat"
sudo nano /etc/rc.local
\end{lstlisting}
and add
\begin{lstlisting}[language={mybash}]
iptables-restore < /etc/iptables.ipv4.nat
nohup python3 /home/pi/RPI_WEB/application.py > /dev/null 2>&1 &
\end{lstlisting}
just above the line 
\begin{lstlisting}[language={mybash}]
exit 0
\end{lstlisting}
\end{comment}
\begin{lstlisting}[language={mybash}]
192.168.4.1:5000
\end{lstlisting}
You should see the typical web interface now.
\clearpage
\section{Usage of existing Unit}
To use an existing unit connect the sensor to the Raspberry Pi (refer to \ref{sensor_connect}) and start the Raspberry Pi by plugging in its power adapter.\\
After startup the local WiFi network should be available and any mobile device can connect and watch the live data at
\begin{lstlisting}[language={mybash}]
192.168.4.1:5000
\end{lstlisting}
The web page includes a view of the last 1000 data points.\\[0.5cm]
To obtain the data as ASCII table just plug in a USB stick. To verify that it is connected, check the web page for \texttt{USB status: connected}. The logging application will now write so far recorded data to the USB stick and continue storing new values as well. Note however, that only a limited amount of values can be buffered, so it is recommended to leave the USB stick inside.\\[0.5cm]
The data is stored using a timestamp giving year, month and so on. In addition time difference to some $t_0$ in the past is given. By default this is the booting time of the Raspberry. For convenience, this $t_0$ can be resetted using the web interface.\\[0.5cm]
In contrast to other computers, the Raspberry Pi does not include a battery. In consequence, no real time clock is included. To overcome this issue, you can connect the Raspberry Pi via Ethernet to a Computer forwarding Internet. The time is then automatically updated at boot time.
\clearpage
\appendix
\section{Connecting the sensor}
\label{sensor_connect}
\begin{figure}[h]
	\centering
	\subfloat[Sensor.]{\includegraphics[height=0.2\textwidth]{sensor.jpg}}\hspace{0.5cm}
	\subfloat[Interconnect of sensor and Raspberry cable.]{\includegraphics[width=0.2\textwidth,angle=90]{interconnect.jpg}}\hspace{0.5cm}
	\subfloat[Connection at Raspberry.]{\includegraphics[height=0.2\textwidth]{raspi.jpg}}
	\caption{Connection of Sensor to Raspberry.}
	\label{pic_connection}
\end{figure}
Like shown in the pictures in \ref{pic_connection} connect the Raspberry cable to the Raspberry, so the cables lead to the outside. Further connect the sensor cable and the Raspberry cable such that the red line is continued.\\[0.5cm]
In the case that connection is not working, check with a multimeter whether cable is broken.
\begin{figure}[h]
	\centering
	\includegraphics[width=0.9\textwidth]{pins.jpg}
	\caption{Pins of the Raspberry Pi, from \url{https://www.elektronik-kompendium.de/sites/raspberry-pi/1907101.htm} on 8.6.2018.}
	\label{pins}
\end{figure}

Figure \ref{pins} shows the pins of the Raspberry Pi, the pins of the sensor are written on the sensor itself. This can also help for making a new cable.
\clearpage
\section{Debugging}
For debugging, having a terminal of the Raspberry is very convenient. There are different possibilities
\begin{enumerate}
	\item Connecting to the local WiFi network and use SSH.
	\item Connect Raspberry via LAN cable and forward internet
	\item Connect peripherals directly to Raspberry
\end{enumerate}
Disadvantage of first option is the lack of internet which is necessary for updating software or pushing changes to git. For the second option the IP address of the Raspberry need to be known.
To obtain, get your own IP address \texttt{aaa.bbb.ccc.ddd} first using \texttt{ifconfig} (or \texttt{ipconfig} on Windows). Afterwards scan the network with e.g. \texttt{nmap} using
\begin{lstlisting}[language={mybash}]
nmap aaa.bbb.ccc.*
\end{lstlisting}
Spotting the IP address of the Raspberry Pi should then be easy.
\\[0.5cm]
\subsection{WiFi network not visible}
The configuration of the local WiFi network on the Raspberry Pi is unfortunately problematic.\\
First check whether the WiFi network is connectable after waiting for 30 seconds.\\
If not restart the Raspberry by taking the power adapter out and plugging it in again. Wait again for 30 seconds.\\
If the WiFi is still not available the easiest solution is to set up a new logging unit. It is strongly recommended to not use the latest Raspbian release but to use the older one as shown above. Not upgrading the software on the Raspberry can also help.
\subsection{WiFi network not accepting password}
After starting up the Raspberry this issue is well known. Wait for one minute and try again.\\
If the password is still refused check the exact spelling of the password. Using a terminal you can open \texttt{/etc/hostapd/hostapd.conf} to verify the password and that you are connecting to the correct WiFi network.
\subsection{Web page not available}
Check whether the IP address and the port number is really correct and latter is not forgot to type in.\\
Since the WiFi network of the Raspberry Pi does not deliver internet connection, most phones will use data connection instead and thus be unable to find the address of the Raspberry Pi online. Try turning off the data connection temporary.\\
Check whether the issue is due to the phone by trying other devices.\\
If the issue still persists run \texttt{ps -e | grep "python3"} on the Raspberry. If no lines are returned the logging application is actually not running.\\
Is it possible that the application crashed, try to restart the Raspberry.\\
For debugging purpose, you can start the application by
\begin{lstlisting}[language={mybash}]
cd RPI_WEB
python3 application.py
\end{lstlisting}
If no problems appear, make sure that the line 
\begin{lstlisting}[language={mybash}]
nohup python3 /home/pi/RPI_WEB/application.py > /dev/null 2>&1 &
\end{lstlisting}
appear inside the file \texttt{/etc/rc.local}.
\subsection{All data is zero}
Zero is the default value given when the sensor is not readable after several tries.\\
Most probable the problem is due to a communication error with the sensor. Connect the sensor and type
\begin{lstlisting}[language={mybash}]
i2cdetect -y 1
\end{lstlisting}
If an error message appears, you probably forget to activate I\textsuperscript{2}C in \texttt{raspi-config}.\\
If no numbers appear in the returned table (numbers at the edge are not included) none I\textsuperscript{2}C devices were found. Most probably the sensor is connected in a wrong way, check section \ref{sensor_connect}.\\
If numbers appear, I\textsuperscript{2}C devices were found, check for number 44 and 45. Default address of the used sensor is \texttt{0x44}, however it is modifiable to use address \texttt{0x45}.\\
You can change the address which the Raspberry Pi uses by opening \texttt{main.py}
\begin{lstlisting}[language={mybash}]
cd RPI_WEB
nano main.py
\end{lstlisting}
Change the line
\begin{lstlisting}[language=mypython]
   def __init__(self, socket, sensor_address = 0x44):
\end{lstlisting}
to
\begin{lstlisting}[language=mypython]
   def __init__(self, socket, sensor_address = 0x45):
\end{lstlisting}

\end{document}
